' 
' -----------------------------------------------------------------------------
' FBinRQ FREEBASIC DIALOG RESOURCE IN RQ CODE    DEMO       April 2009, Jacques
' -----------------------------------------------------------------------------
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
' Decalre the exported FB Function
Declare Function ShowDialog Lib "DlgResource.Exe" Alias "ShowDialog@0" () As Integer
Declare Function FBEncrypt Lib "DlgResource.Exe" Alias "FBEncrypt@8"(ptrString As Integer, _
                                                            lenString as Integer) As Integer
Declare Function FBDncrypt Lib "DlgResource.Exe" Alias "FBDecrypt@8"(ptrString As Integer, _
                                                            lenString as Integer) As Integer
'
DefStr sTest = "abcdefghijklmnopqrstuvwxyz"
Print "sTest  original: //";sTest
FBEncrypt (VarPtr(sTest), Len(sTest))
Print "sTest Encrypted:\n//";sTest
ShowDialog
FBDncrypt (VarPtr(sTest), Len(sTest))
Print "sTest DeCrypted: //";sTest
' -----------------------------------------------------------------------------
DefStr sExit
Input "\n\n                    CR to QUIT \n\n", sExit
Application.Terminate
' ==== END RQ CODE ============================================================
'
' -----------------------------------------------------------------------------
' START FREEBASIC CODE 1     Includes FreeBasic Code       ROR 3 Asm encrypting 
' -----------------------------------------------------------------------------
'
$IFDEF FBB              ' btw: function used to encrypt bytecode
Declare Function FBEncrypt Lib "" Alias "FBEncrypt" (ptrString As Integer, lenString as Integer) As Integer
Declare Function FBDecrypt Lib "" Alias "FBDecrypt" (ptrString As Integer, lenString as Integer) As Integer
Function FBEncrypt (ptrString As Integer, lenString as Integer) As Integer export
    asm
        mov esi, [ptrString]
        mov edx, [lenString]
        sub edx, 4
        .LoopEncrypt:
             cmp edx, 4
             jc .EncryptFinished
                 mov eax, [esi]
                 ror eax, 3
                 mov [esi], eax
                 sub edx, 4
                 add esi, 4
        jmp .LoopEncrypt
        .EncryptFinished:
    end asm
    Function = 0
End Function
'
Function FBDecrypt (ptrString As Integer, lenString as Integer) As Integer export
    asm
        mov esi, [ptrString]
        mov edx, [lenString]
        sub edx, 4
        .LoopDecrypt:
             cmp edx, 4
             jc .DecryptFinished
                 mov eax, [esi]
                 rol eax, 3
                 mov [esi], eax
                 sub edx, 4
                 add esi, 4
        jmp .LoopDecrypt
        .DecryptFinished:
    end asm
    Function = 0
End Function

$ENDIF
' -----------------------------------------------------------------------------
' END FREEBASIC CODE 1
' -----------------------------------------------------------------------------



' -----------------------------------------------------------------------------
' START FREEBASIC RESOURCE in RQ Code (Dialog Window)
' -----------------------------------------------------------------------------
$IFDEF FBR
    #define IDD_DLG1 1000 
    #define IDC_BTN1 1001

    IDD_DLG1 DIALOGEX 6,6,300,102 
    CAPTION "HELLO RAPIDQ USERS, I AM A FREEBASIC RESOURCE DIALOG WINDOW" 
    FONT 16,"Courier New" 
    STYLE 0x10CC0000
    EXSTYLE 0x00000080 
    BEGIN
        CONTROL "Click me to decrypt string",IDC_BTN1,"Button",0x50010000,60,57,150,26,0x00000000
    END
$ENDIF
' -----------------------------------------------------------------------------
' END FREEBASIC RESOURCE
' -----------------------------------------------------------------------------

' -----------------------------------------------------------------------------
' START FREEBASIC CODE 2     Includes FreeBasic Code Displaying Dialog Resource
' -----------------------------------------------------------------------------
$IFDEF FBB
    #define IDD_DLG1 1000 
    #define IDC_BTN1 1001

    Declare Function DlgProc (byval hwnd as HWND, byval umsg as UINT, byval wparam as WPARAM, byval lparam as LPARAM) as BOOL
    Declare Function ShowDialog Lib "" Alias "ShowDialog" () As Integer
    '
    Function ShowDialog () As Integer Export
        DialogBoxParam(GetModuleHandle( NULL ), cast( LPCSTR, IDD_DLG1 ), NULL, @DlgProc, NULL ) 
    End Function
'                                 
    function DlgProc (byval hwnd as HWND, byval umsg as UINT, byval wparam as WPARAM, byval lparam as LPARAM) as BOOL
        dim as long id, event
        select case uMsg
        case WM_INITDIALOG
 
        case WM_CLOSE
            EndDialog( hwnd, 0 ) 

        case WM_COMMAND
            id    = loword( wParam )
            event = hiword( wParam )
    
            select case id
                case IDC_BTN1
                    EndDialog( hwnd, 0 )
            end select
        
       case else
            return FALSE
       end select
       return TRUE
    end function 
$ENDIF
' -----------------------------------------------------------------------------
' END FREEBASIC CODE 2
' -----------------------------------------------------------------------------
'
