'
' -----------------------------------------------------------------------------
' FBinRQ ADD RQ INLINE RH RESOURCE by Name   DEMO           April 2009, Jacques
' -----------------------------------------------------------------------------
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
' ---------------------------------------------------------
Declare Function FindResource Lib "KERNEL32" Alias "FindResourceA" (ByVal hLib As Long, _
                                    ByVal strName As Long, ByVal strType As Long) As Long
Declare Function SizeofResource Lib "KERNEL32"  Alias "SizeofResource" _
                                  (ByVal hModule As Long, ByVal hResInfo As Long) As Long 
Declare Function LoadResource Lib "Kernel32" Alias "LoadResource" (ByVal hLib As Long, ByVal hRes As Long) As Long
Declare Function LockResource Lib "KERNEL32" Alias "LockResource" (ByVal hRes As Long) As Long
' ---------------------------------------------------------
'
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
Declare Sub OnClose_frmEnumResources
'
Create frmEnumResources As QForm
    Center
    Width = 1000
    height = 800
    Caption = "GetResource in current Module: " & Application.Exename
    AutoScroll = False
    OnClose = OnClose_frmEnumResources
    Create rchWin AS QRichEdit
        Align = 5
        Font.Name = "courier"
        Font.Size = 12
        Font.Color = &H800000
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False 
        PlainText = True
    End Create
End Create
'
' FBinRQ add a RH Resource at compile time in FB Bytecode Launcher
' ----------------------------------------------------------------
' // Comment char in RHK Resources  as in C
' ----------------------------------------------------------------
' START ADD RH RESOURCE  USER DEFINED TYPE 
' ----------------------------------------------------------------
$IFDEF RHK                
-addoverwrite RH_GetSetResourceByNames.Bas, RQ_TEXT, THIS_RQ_CODE, 0  //any names
$ENDIF
' ----------------------------------------------------------------
' END ADD RH RESOURCE
' ----------------------------------------------------------------
'
' Read the resource at run time
' -----------------------------
' Resource Name and Type
DefInt hModule = 0           ' Zero for this application
' Get Resource Size and Address (=handle)
DefStr sResTYPE="RQ_TEXT", sResNAME = "THIS_RQ_CODE"
DefInt hResInfo = FindResource (hModule, VarPtr(sResName), VarPtr(sResType))
DefInt iResSize = SizeofResource (hModule, hResInfo)
DefInt hRes     = LoadResource (hModule, hResInfo)
DefInt ptrRes   = LockResource (hRes)
'
rchWin.Addstring "\n  Get Resource Position and Size" _
               & "\n  ------------------------------" _
               & "\n  hRes Info: " & Str$(hResInfo) _
               & "\n  iRes Size: " & Str$(iResSize) _
               & "\n  hResource: " & Str$(hRes) _
               & "\n    ptrRsrc: " & Str$(ptrRes)
'
' Copy resource in a string to display it
DefStr sData = Space$(iResSize)
MemCpy (VarPtr(sData), hRes, iResSize)
'
rchWin.Text = rchWin.Text & _
        & "\n\n\n" & String$(80, "=") _
            & "\nContent of Resource Name:THIS_RQ_CODE;Type:RQ_TEXT" _
            & "\n" & String$(80, "=") _
            & "\n" & sData _
            & "\n" & String$(80, "=") _
            & "\nEnd of Resource Name:THIS_RQ_CODE;Type:RQ_TEXT" _
            & "\n" & String$(80, "=")
'
' *************************************
frmEnumResources.ShowModal
' *************************************
'
Sub OnClose_frmEnumResources
    Application.Terminate
End Sub
'
