'
' -----------------------------------------------------------------------------
' frmFBinRQIDE        FBinRQ compile any RQ Code           April  2009  Jacques
' -----------------------------------------------------------------------------
'
''pre cmd con enc opt upx DirIcon kill run adddll FBinRQ_IDE.Dll
DefStr BuildCount = "0.072" ''pre + 0.001 3
DefStr FirstCompiled  =  "04-20-2009  23:12:48"'
''pre end
'
$INCLUDE "Qini2.Inc"
$INCLUDE "QREDEX_OLD.INC"
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
' DOC_TEXT  CompileTime Add Resource
Const iFBinRQ_DOC = 0
$RESOURCE FBinRQDOC AS "FBinRQ_Doc.Txt"
' DOC_TEXT Copy Resource in String
Dim msTmp As QMemoryStream
msTmp.ExtractRes (Resource(iFBinRQ_DOC))
msTmp.Position = 0
DefStr sFBinRQ_Doc = msTmp.ReadBinStr (msTmp.Size)
msTmp.Close
'
$RESOURCE FORM_ICO AS "$ModArt48.ico"
'
Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, _
                              ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
'
Declare Sub OnClose_frmFBinRQIDE
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
Declare Sub OnClic_btnRefresh
Declare Sub OnChange_Directory
Declare Sub OnChange_edtFileFilter (Key As Long)
Declare Sub OnDblClick_lstFiles
Declare Sub OnMouseDown_rchWin
'
Dim myIni As QIni
'
Create frmFBinRQIDE As QForm
    Center
    Width = Val(myIni.Read ("FormWidth", "900"))
    height = Val(myIni.Read ("FormHeight", "800"))
    Caption = "frmFBinRQIDE" & " V" & BuildCount
    AutoScroll = False
    OnClose = OnClose_frmFBinRQIDE
    Font.Size = 10
    Font.Bold = True
    IcoHandle = FORM_ICO
    Create pnlRight As QPanel    
        Width = Val(myIni.Read("pnlRightWidth", Str$(frmFBinRQIDE.ClientWidth * 0.25)))
        Align = alRight
        Font.Size = 10
        Font.Bold = True
        Create dirTree AS QDirTree
            Height =  Val(myIni.Read("dirTreeHeight", Str$(frmFBinRQIDE.ClientHeight/2)))
            Align = alTop
            InitialDir = CURDIR$
            OnChange = OnChange_Directory
        End Create
        Create pnlRightTop As QPanel
            Height = 75
            Align = alTop
            Create btnRefresh AS QButton
                Height = 25
                Align = alTop
                Font.Bold = True
                Font.Size = 12
                Caption = "&REFRESH"
                OnClick = OnClic_btnRefresh
            End Create
            Create pnlRightTop_up As QPanel
                Height = 25
                Align = alTop
                Create lblMyLabel As QLabel
                    Height = 25
                    align = alLeft
                    Font.Size = 12
                    Caption = " Files Filter : "
                End Create
                Create edtFileFilter AS QEdit
                    align = alClient
                    Width = 60
                    Height = 25
                    Font.Size = 8
                    Font.Bold = True
                    Text =  myIni.Read ("FileFilter", "*.Bas;*.Inc;*.rqb;*.rqw;*.rpi;*.Fbb;*.Bi")
                    OnChange = OnChange_edtFileFilter
                    ShowHint = True
                    Hint = "Filter For Files, WildCards Allowed (*, ?)"
                End Create
            End Create
            Create edtDirectory AS QEdit
                Height = 25
                align = alClient
                Font.Bold = True
            End Create
        End Create
        Create Splitter_H AS QSPLITTER
            Align = alTop
            Cursor = crVSplit
            MinSize = 100
            Height = 8
            Color = &H00FF00
        End Create
        Create lstFiles AS QFileListBox
            Height = 300
            Align = alClient
            Mask = "*.*"
            OnDblClick = OnDblClick_lstFiles
        End Create
    End Create
    Create Splitter_V AS QSPLITTER
        Width = 8
        Align = alRight
        Cursor = crHSplit
        MinSize = 100
        Color = &HFF0000
    End Create
    Create pnlLeft As QPanel
        Align = alClient
        Create lblLeftTop As QLabel
            AutoSize = False
            Height = 100
            Align = alTop
            Alignment = taCenter
            Color = &HFFEEEE
            Font.Name = "Courier"
            Font.Size = 12
            Font.Bold = True
            Font.Color = &H000075
            WordWrap = True
            Caption = "THIS IS ONLY A DEMO. IT SHOULD COMPILE ANY RAPIDQ CODE. FIND THEM IN RIGHT PANEL \n" _
                    & "\n NOT DEEPLY TESTED. IF I BUG, CLOSE FBinRQ_IDE.EXE'S ASSOCIATED CONSOLE" _
                    & "\nTHE REAL THING CALLS Path\\FBinRQ.Exe Path\\YourBAsFile.AnyExt FROM YOUR IDE" _
                    & "\nTry each of ''pre cmd kill con adddll enc opt nobeep nofbrecompile upx diricon run exe out"
        End Create
        Create rchWin AS QRichEdit
            Align = alClient
            Alignment = taCenter
            Font.Name = "courier"
            Font.Size = 25
            Font.Color = &H550000
            Font.Bold = True
            Color = &HE4F8F7
            ReadOnly = False
            WordWrap = False
            ScrollBars = ssBoth
            HideSelection = False
            PlainText = True
            Text = "\n\n\nIF I CRASH, CLOSE MY CONSOLE\n\nNever happens here"
            ExtendSizeLimit
            OnMouseDown = OnMouseDown_rchWin
            OnKeyUp = OnMouseDown_rchWin
        End Create
        Create StatusBar AS QStatusBar
            AddPanels "", "", ""
            Height = 30
            Panel(0).Width = 60
            Panel(1).Width = 60
            Panel(2).Alignment = taRightJustify
        End Create
    End Create
    Create mnuMain AS QMAINMENU
        Create mnuCompile AS QMENUITEM
            Caption = "&FBinRQ_Compile"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuDoc AS QMENUITEM
            Caption = "FBinRQ  &Documentation<>Code  Switch"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuViewIni AS QMENUITEM
            Caption = "Show_FBinRQ.&Ini"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuClear AS QMENUITEM
            Caption = "&CLEAR"
            OnClick = OnClic_AnyMenu
        End Create
    End Create
End Create
' ---------------------------------------------------------------------
' To Correct RapidQ Minimizing on the DeskTop
' -------------------------------------------
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, nIndex AS LONG, dwNewLong AS LONG) AS LONG
SUB MinSet (fhand as integer, gwl_hand as integer, hwnd as integer, apphand as integer)
    setwindowlong(fhand, Gwl_Hand, hwnd)
    setwindowlong(apphand, GWL_Hand, fhand)
End SUB
MinSet(frmFBinRQIDE.handle, -8, 0, application.handle)
' ---------------------------------------------------------------------
DefStr sNowDir
DefStr sSelPath = "", sSelFile = "", sSelPathFile = "", sSelFileNoExt = "", sSelExt = ""
DefStr sAppDir = Command$(0) - Application.ExeName
sNowDir = myIni.Read ("InitialDir", sAppDir)
edtDirectory.Text = sNowDir
dirTree.InitialDir = sNowDir
ChDir sNowDir
lstFiles.Directory = sNowDir
DefInt flagMenuBusy = False
'
' *************************************
frmFBinRQIDE.Show
' *************************************
'
DefStr sTmp, sRchWinText
DefInt iFbinRqConFigOK = Val(myIni.Read("PATH_FILES_OK_PRESENT", "0"))
DefInt iFlagDocShowed = False
OnClic_btnRefresh
'
' *************************************
frmFBinRQIDE.Visible = False
frmFBinRQIDE.ShowModal
' *************************************
'
Sub OnDblClick_lstFiles
    DefInt iPtr
    rchWin.Font.Size = 12
    rchWin.Alignment = taLeftJustify
    sSelFile = lstFiles.Item(lstFiles.ItemIndex)
    sSelPath = dirTree.Directory
    sSelPathFile = sSelPath & sSelFile
    ' *EXT  includes the "." dot
    iPtr = RInstr (sSelFile, ".")
    If iPtr = 0 Then
        sSelExt = ""
        sSelFileNoExt = sSelFile
    Else
        sSelExt = Mid$(sSelFile, iPtr)
        sSelFileNoExt = Left$(sSelFile, iPtr - 1)
    End If
'    ShowMessage ("      sSelExt : " & sSelExt _
'             & "\nsSelFileNoExt : " & sSelFileNoExt _
'             & "\n     sSetFile : " & sSelFile _
'             & "\n     sSelPath : " & sSelPath _
'             & "\n sSelPathFile : " & sSelPathFile)
    sNowDir = sSelPath
    CopyFile (sSelPathFile, sSelPathFile & ".Org", 0)
    rchWin.LoadFromFile (sSelPathFile)
    StatusBar.Panel(2).Caption = sSelPathFile & "     "
    rchWin.Modified = False
End sub
'
Sub OnClic_AnyMenu (Sender)
    DefStr sFile, sFbInRqOut, sExePathFile, sShell
    DefInt N, iLen, flagSpace, iDir = 0, iRet
    Dim slTmp As QStringList
    rchWin.Font.Size = 12
    rchWin.Alignment = taLeftJustify
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    Select Case Sender.Handle
        Case mnuCompile.Handle
            If iFlagDocShowed = True Then
                ShowMessage ("Cant Compile the Doc: Click again Menu Documentation <> Code")
                flagMenuBusy = False
                Exit Sub
            End IF
            If fileExists (sAppDir & "FBinRQ.Exe") = 0 Then
                ShowMessage("FbinRQ.Exe not found in:\n\n" & sAppDir & "\n\n    I  QUIT")
                Application.Terminate
            Else
                If (rchWin.Modified = True And Len(rchWin.Text) > 100) Then
                    If MessageDlg("Window Text has changed!\n\nDo I discard the changes?", mtConfirmation, mbYes OR mbNo, 0) = IdNo Then
                        ' make a new backup copy of .Bas FILE before saving changes
                        Kill sSelPathFile & ".Bak"                        ' delete the old one
                        CopyFile (sSelPathFile, sSelPathFile & ".Bak", 0) ' copy .Bas to .Bas.Org
                        Kill sSelPathFile                                 ' We can now kill .Bas
                        rchWin.SaveToFile (sSelPathFile)                  ' Save the changed .Bas                   End If
                    End If
                End If
                sExePathFile = sSelPath & sSelFileNoExt & ".Exe"
                Kill sExePathFile                                         ' Delete the old exe
                ' recompile the EXE with FBinRQ.Exe
                sShell = sAppDir & "FBinRQ.Exe " & sSelPathFile
                iRet = Shell (sShell, 1)
                ' DO NOT WAIT .Exe exists FBinRQ does it
                OnClic_btnRefresh
            End If
        Case mnuClear.Handle
            rchWin.Clear
            sSelPathFile = ""
            StatusBar.Panel(2).Caption = sSelPathFile & "     "
        Case mnuDoc.Handle
            If iFlagDocShowed = False Then
                iFlagDocShowed = True
                rchWin.ReadOnly = True
                rchWin.Color = &H0B230A
                rchWin.Font.Color = &H6DF8F4
                sRchWinText = rchWin.Text
                rchWin.Text = sFBinRQ_Doc
            Else
                iFlagDocShowed = False
                rchWin.ReadOnly = True
                rchWin.Font.Color = &H550000
                rchWin.Color = &HE4F8F7
                rchWin.Text = sRchWinText
            End If   
        Case mnuViewIni.Handle
            If FileExists (sAppDir & "FBinRQ.Ini") <> 0 Then
                slTmp.LoadFromFile (sAppDir & "FBinRQ.Ini")
                ShowMessage slTmp.Text  
            Else
                ShowMessage "File not found:\n\n" & sAppDir & "FbinRQ.Ini"
            End If
    End Select
    flagMenuBusy = False
End Sub
'
Sub OnChange_edtFileFilter (Key As Long)
        lstFiles.Mask =  edtFileFilter.Text
        lstFiles.Update
End sub
'
SUB OnChange_Directory
    sNowDir = DirTree.Directory
    edtDirectory.Text = sNowDir
    ChDir sNowDir
    lstFiles.Directory = sNowDir
End SUB
'
Sub OnClose_frmFBinRQIDE
    myIni.Write ("FormWidth", Str$(frmFBinRQIDE.Width))
    myIni.Write ("FormHeight", Str$(frmFBinRQIDE.Height))
    myIni.Write ("pnlRightWidth", Str$(pnlRight.Width))
    myIni.Write ("FileFilter", edtFileFilter.Text)
    myIni.Write ("dirTreeHeight", Str$(dirTree.Height))
    myIni.Write ("InitialDir", sNowDir)
    Application.Terminate
End Sub
'
Sub OnClic_btnRefresh
    lstFiles.Mask =  edtFileFilter.Text
    lstFiles.Update
    dirTree.Reload
End Sub
'
Sub OnMouseDown_rchWin
    StatusBar.Panel(0).Caption = "L_: " & Str$(1 + rchWin.WhereY)
    StatusBar.Panel(1).Caption = "C_: " & Str$(1 + rchWin.WhereX)
End Sub
'
