'
' -----------------------------------------------------------------------------
' QINI2                                                     2001        Jacques             
' -----------------------------------------------------------------------------
Declare Function JPI_GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
      (lpApplicationName As String, lpKeyName As String, lpDefault As String, _
       lpReturnedString As Long, nSize As Long, lpFileName As String) As Long
'
Declare Function JPI_WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" _
      (ByRef lpApplicationName As String, ByRef lpKeyName As String, ByRef lpString As String, _
                                                            ByVal lpFileName As String) As Long
' -----------------------------------------------------------------------------
'
Type Qini Extends Qobject
    Filename As String      ' WITH  PATH  MANDATORY
    Section As String
    '
    Function Read(Key As String, DefaultValue As String) As String
        Defstr Lpbuffer = Space$(260)
        DefInt iLen
        iLen = JPI_GetPrivateProfileString(Qini.Section, Key, DefaultValue, _
                                                  Varptr(Lpbuffer), 260, Qini.Filename)
        Result = Left$(Lpbuffer, iLen)
    End Function
    '
    Function Write(Key As String, Value As String) As Long
        DefStr sKey = Key          '  To allow  "" as Null String to be passed
        DefStr sValue = Value      '  + ByRef As String In Api in Declare
        Result = JPI_WritePrivateProfileString(Qini.Section, sKey, sValue, Qini.Filename)
    End Function
    '
    CONSTRUCTOR
        FileName = (Ucase$(Command$(0)) - ".EXE") + ".INI"
        Section  = Ucase$(application.exeName) - ".EXE"
    END CONSTRUCTOR
    '
End Type
'
' =============================================================================
'

